PROGRAM exercise3a_2
IMPLICIT NONE

INTEGER :: istat, rstat=0, rdf=5, count=0
LOGICAL :: exst
CHARACTER (LEN=*), PARAMETER :: rfile = "mdata.txt"
REAL :: sp1, sp2, sp3, ges1=0, ges2=0, ges3=0

! check if file exists
INQUIRE (FILE=rfile, EXIST=exst)
IF (.not.exst) THEN
  PRINT *, "File <", rfile, "> does not exist."
  STOP 42
END IF

! open file
OPEN (UNIT=rdf, FILE=rfile, ACTION="read", STATUS="old", IOSTAT=istat)
   IF (istat /= 0) THEN
      PRINT *, "File cannot be opened."
      STOP 23
   END IF

   ! loop: read in all data sets
   DO
   ! read in 3 columns
   READ (rdf, *, IOSTAT=rstat) sp1, sp2, sp3
   ! exit if end of file
   IF (rstat /= 0) EXIT
   ! sum up the values of each column
   ges1  = ges1+sp1
   ges2  = ges2+sp2
   ges3  = ges3+sp3
   count = count+1
END DO

! close file
CLOSE (rdf)

! print out the mean value of each column
PRINT *, "Number of data sets: ", count
PRINT *, 1, ges1/count
PRINT *, 2, ges2/count
PRINT *, 3, ges3/count

END Program exercise3a_2
